/********************************** (C) COPYRIGHT *******************************
* File Name          : DEBUG.C
* Author             : WCH
* Version            : V1.0
* Date               : 2017/01/20
* Description        : CH554 DEBUG Interface
                     (1)0ӡϢʿɱ;              				   
*******************************************************************************/

#include "CH554.H"
#include "DEBUG.H"

/*******************************************************************************
* Function Name  : CfgFsys( )
* Description    : CH554ʱѡú,Ĭʹڲ12MHzFREQ_SYS
                   PLL_CFGCLOCK_CFGõõʽ£
                   Fsys = (Fosc * ( PLL_CFG & MASK_PLL_MULT ))/(CLOCK_CFG & MASK_SYS_CK_DIV);
                   ʱҪԼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void	CfgFsys( )  
{
// 		SAFE_MOD = 0x55;
// 		SAFE_MOD = 0xAA;
//     CLOCK_CFG |= bOSC_EN_XT;                          //ʹⲿ
//     CLOCK_CFG &= ~bOSC_EN_INT;                        //رڲ    
		SAFE_MOD = 0x55;
		SAFE_MOD = 0xAA;
// 		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x07;  // 32MHz	
// 		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x06;  // 24MHz	
 		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x05;  // 16MHz	
//		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x04;  // 12MHz
// 		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x03;  // 6MHz	
// 		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x02;  // 3MHz	
// 		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x01;  // 750KHz	
// 		CLOCK_CFG = CLOCK_CFG & ~ MASK_SYS_CK_SEL | 0x00;  // 187.5MHz		
		SAFE_MOD = 0x00;
}

/*******************************************************************************
* Function Name  : mDelayus(UNIT16 n)
* Description    : usʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/ 
void	mDelayuS( UINT16 n )  // uSΪλʱ
{
#ifdef	FREQ_SYS
#if		FREQ_SYS <= 6000000
		n >>= 2;
#endif
#if		FREQ_SYS <= 3000000
		n >>= 2;
#endif
#if		FREQ_SYS <= 750000
		n >>= 4;
#endif
#endif
	while ( n ) {  // total = 12~13 Fsys cycles, 1uS @Fsys=12MHz
		++ SAFE_MOD;  // 2 Fsys cycles, for higher Fsys, add operation here
#ifdef	FREQ_SYS
#if		FREQ_SYS >= 14000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 16000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 18000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 20000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 22000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 24000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 26000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 28000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 30000000
		++ SAFE_MOD;
#endif
#if		FREQ_SYS >= 32000000
		++ SAFE_MOD;
#endif
#endif
		-- n;
	}
}

/*******************************************************************************
* Function Name  : mDelayms(UNIT16 n)
* Description    : msʱ
* Input          : UNIT16 n
* Output         : None
* Return         : None
*******************************************************************************/
void	mDelaymS( UINT16 n )                                                  // mSΪλʱ
{
	while ( n ) {
#ifdef	DELAY_MS_HW
		while ( ( TKEY_CTRL & bTKC_IF ) == 0 );
		while ( TKEY_CTRL & bTKC_IF );
#else
		mDelayuS( 1000 );
#endif
		-- n;
	}
}                                         

/*******************************************************************************
* Function Name  : CH554UART0Alter()
* Description    : CH5540ӳ,
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH554UART0Alter()
{
    PIN_FUNC |= bUART0_PIN_X;                                                  //ӳ䵽P1.2P1.3
}

/*******************************************************************************
* Function Name  : mInitSTDIO()
* Description    : CH5540ʼ,ĬʹT1UART0Ĳʷ,ҲʹT2
                   Ϊʷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void	mInitSTDIO( )
{
    UINT32 x;
    UINT8 x2; 

    SM0 = 0;
    SM1 = 1;
    SM2 = 0;                                                                   //0ʹģʽ1
                                                                               //ʹTimer1Ϊʷ
    RCLK = 0;                                                                  //UART0ʱ
    TCLK = 0;                                                                  //UART0ʱ
    PCON |= SMOD;
    x = 10 * FREQ_SYS / UART0_BUAD / 16;                                       //ƵעxֵҪ                            
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                       //

    TMOD = TMOD & ~ bT1_GATE & ~ bT1_CT & ~ MASK_T1_MOD | bT1_M1;              //0X20Timer1Ϊ8λԶضʱ
    T2MOD = T2MOD | bTMR_CLK | bT1_CLK;                                        //Timer1ʱѡ
    TH1 = 0-x;                                                                 //12MHz,buad/12Ϊʵò
    TR1 = 1;                                                                   //ʱ1
    REN = 1;                                                                   //0ʹ
	TI = 1;
}

/*******************************************************************************
* Function Name  : CH554UART0RcvByte()
* Description    : CH554UART0һֽ
* Input          : None
* Output         : None
* Return         : SBUF
*******************************************************************************/
UINT8  CH554UART0RcvByte( )
{
    while(RI == 0);                                                            //ѯգжϷʽɲ
    RI = 0;
    return SBUF;
}

/*******************************************************************************
* Function Name  : CH554UART0SendByte(UINT8 SendDat)
* Description    : CH554UART0һֽ
* Input          : UINT8 SendDatҪ͵
* Output         : None
* Return         : None
*******************************************************************************/
void CH554UART0SendByte(UINT8 SendDat)
{
	SBUF = SendDat;                                                              //ѯͣжϷʽɲ2,ǰTI=0
	while(TI ==0);
	TI = 0;
}

/*******************************************************************************
* Function Name  : UART1Setup()
* Description    : CH5541ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void	UART1Setup( )
{
  U1SM0 = 0;                                                                   //UART1ѡ8λλ
  U1SMOD = 1;                                                                  //ģʽ
  U1REN = 1;                                                                   //ʹܽ
  SBAUD1 = 0 - FREQ_SYS/16/UART1_BUAD;
  IE_UART1 = 1;
  EA = 1;
}

/*******************************************************************************
* Function Name  : CH554UART1RcvByte()
* Description    : CH554UART1һֽ
* Input          : None
* Output         : None
* Return         : SBUF
*******************************************************************************/
UINT8  CH554UART1RcvByte( )
{
    while(U1RI == 0);                                                           //ѯգжϷʽɲ
    U1RI = 0;
    return SBUF1;
}

/*******************************************************************************
* Function Name  : CH554UART1SendByte(UINT8 SendDat)
* Description    : CH554UART1һֽ
* Input          : UINT8 SendDatҪ͵
* Output         : None
* Return         : None
*******************************************************************************/
void CH554UART1SendByte(UINT8 SendDat)
{
	SBUF1 = SendDat;                                                             //ѯͣжϷʽɲ2,ǰTI=0
	while(U1TI ==0);
	U1TI = 0;
}

/*******************************************************************************
* Function Name  : CH554WatchDog(UINT8 mode)
* Description    : CH554Źģʽ
* Input          : UINT8 mode 
                   0  timer
                   1  watchDog
* Output         : None
* Return         : None
*******************************************************************************/
void CH554WatchDog(UINT8 mode)
{
  SAFE_MOD = 0x55;
  SAFE_MOD = 0xaa;                                                             //밲ȫģʽ
  if(mode){
    GLOBAL_CFG |= bWDOG_EN;
  }
  else GLOBAL_CFG &= ~bWDOG_EN;	
  SAFE_MOD = 0x00;                                                             //˳ȫģʽ
  WDOG_COUNT = 0;                                                              //Źֵ
}

/*******************************************************************************
* Function Name  : CH554WatchDogFeed(UINT8 tim)
* Description    : CH554Źι
* Input          : UINT8 tim Źλʱ
                   00H(6MHz)=2.8s
                   80H(6MHz)=1.4s
* Output         : None
* Return         : None
*******************************************************************************/
void CH554WatchDogFeed(UINT8 tim)
{
  WDOG_COUNT = tim;                                                             //Źֵ	
}